export default class UnityLoaderService {
    /**
     * A reference to the document head.
     * @type {HTMLHeadElement}
     */
    private documentHead;
    /**
     * A reference to the UnityLoader script.
     * @type {HTMLScriptElement}
     */
    private unityLoaderScript?;
    /**
     * Appends the Unity loader script to the window. When a version of the loader
     * is already appended, we'll skip right away. When another loader is try to
     * append, the previous will be removed first.
     * @param {string} url the path to the Unity loader file
     * @param {Function} onLoad when the script is loaded
     * @returns A promise when resolving when the file is loaded.
     */
    load(url: string): Promise<void>;
}
//# sourceMappingURL=unityLoaderService.d.ts.map